from __future__ import division

import numpy as np
import numpy.linalg as la


def apply_kernel(a, b, mesh, kernel, density):
    r"""Return a vector *F* corresponding to

    .. math::

        F(x) = \int_a^b k(x,z) \phi(z) dz

    evaluated at all points of *mesh* using the
    trapezoidal rule.

    :arg mesh: A 1D array of nodes in the interval :math:`[a, b]`,
          with the first equal to :math:`a` and the last equal to :math:`b`.
    :arg kernel: two-argument vectorized callable ``kernel(tgt, source)``
        that evaluates
    :arg density: Values of the density at the nodes of *mesh*.
    """

    # insert code here


def solve_bvp(a, b, mesh, p, q, r, ua, ub):
    r"""Solve the boundary value problem

    .. math::

        u''+p(x)u'+q(x)u=r(x),\quad u(a) = u_a,\quad u(b) =u_b

    on *mesh*. Return a vector corresponding to the solution *u*.
    Uses :func:`apply_fredholm_kernel`.

    :arg mesh: A 1D array of nodes in the interval :math:`[a, b]`,
          with the first equal to :math:`a` and the last equal to :math:`b`.
    :arg p, q, r: Functions that accept a vector *x* and
      evaluate the functions $p$, $q$, $r$ at the nodes in *x*.
    """

    # insert code here
