from __future__ import division

import numpy as np
import numpy.linalg as la


def my_gmres_d(A_func, b, tol=1e-10):
    """Solve Ax = b to an absolute residual norm of at most tol.

    Returns a tuple (x, num_iterations).

    Solution to Part 2(d) of the project assignment.
    """

    # insert code here


def my_gmres_e(A_func, b, tol=1e-10):
    """Solve Ax = b to an absolute residual norm of at most tol.

    Returns a tuple (x, num_iterations).

    Solution to Part 2(e) of the project assignment.
    """

    # insert code here


def test_gmres(gmres_func):
    n = 100
    eigvals = 1 + 10**np.linspace(1, -20, n)
    eigvecs = np.random.randn(n, n)
    A = np.dot(
            la.solve(eigvecs, np.diag(eigvals)),
            eigvecs)

    def A_func(x):
        return np.dot(A, x)

    x_true = np.random.randn(n)
    b = np.dot(A, x_true)
    x, num_it = gmres_func(A_func, b)

    print "converged after %d iterations" % num_it
    print "residual: %g" % (la.norm(np.dot(A, x) - b)/la.norm(b))
    print "error: %g" % (la.norm(x-x_true)/la.norm(x_true))


if __name__ == "__main__":
    print "----------------------------------------"
    print "part(d)"
    print "----------------------------------------"
    test_gmres(my_gmres_d)
    print "----------------------------------------"
    print "part(e)"
    print "----------------------------------------"
    test_gmres(my_gmres_e)
